let system = server.registerSystem(0,0);
let clientPlayer;
let playerTickingArea;
system.initialize = function() {
    this.listenForEvent("portals:player_joined",(eventData) => system.onJoin(eventData));
    this.listenForEvent("minecraft:player_placed_block",(eventData) => system.blockPlaced(eventData));
};

system.onJoin = function(eventData){
    this.runCommand(`/say Server Player Registered`);
    clientPlayer = eventData.data.player;
    let tickWorld = this.getComponent(clientPlayer,"minecraft:tick_world");
    playerTickingArea = tickWorld.data.ticking_area;
};
system.blockPlaced = function(eventData) {
    let blockData = this.getBlock(playerTickingArea,eventData.data.block_position);
    let placedBlock = blockData.__identifier__;
    let playerRotation = this.getComponent(clientPlayer,"minecraft:rotation");
    let RotY = playerRotation.data.y
    let RotCommand = `/setblock ${eventData.data.block_position.x} ${eventData.data.block_position.y} ${eventData.data.block_position.z} portal_controller_`

    if (placedBlock === "portals:portal_controller_placement") {
        if (RotY >= -45 && RotY <= 45) {
            this.runCommand(`${RotCommand + "south"}`)
        }
        else if(RotY >= 135 || RotY <= -135) {
            this.runCommand(`${RotCommand + "north"}`)
        }
        else if(RotY > -135 && RotY < -45) {
            this.runCommand(`${RotCommand + "east"}`)
        }
        else {
            this.runCommand(`${RotCommand + "west"}`)
        }
    }

}
system.runCommand = function(command) {
	eventData = this.createEventData("minecraft:execute_command")
	eventData.data.command = command
	this.broadcastEvent("minecraft:execute_command",eventData)
};


system.update = function () {}