let system = server.registerSystem(0,0);
let validBlocks = ["portals:portal_controller_lime_north", "portals:portal_controller_lime_south", "portals:portal_controller_lime_east", "portals:portal_controller_lime_west"];
let clientPlayer;
let playerTickingArea;
let playerName;
let portalAScore;
let portalBScore;



system.initialize = function() {
	this.listenForEvent("portals:player_joined",(eventData) => system.onJoin(eventData));
	this.listenForEvent("minecraft:block_interacted_with",(eventData) => system.onInteract(eventData));
	this.listenForEvent("minecraft:player_destroyed_block",(eventData) => system.onDestruct(eventData));
};

system.onJoin = function(eventData) {
	clientPlayer = eventData.data.player;
    let tickWorld = this.getComponent(clientPlayer,"minecraft:tick_world");
	playerTickingArea = tickWorld.data.ticking_area;
	let getName = this.getComponent(clientPlayer,"minecraft:nameable");
	playerName = getName.data.name;
};

system.onDestruct = function(eventData) {
	let X = eventData.data.block_position.x;
	let Y = eventData.data.block_position.y;
	let Z = eventData.data.block_position.z;
	let blockID = eventData.data.block_identifier;
	let direction = blockID.slice(31,37);
	let FrameDestroyEast = [[X,Y,Z+1],[X,Y,Z+2],[X,Y,Z+3],[X,Y+1,Z+3],[X,Y+2,Z+3],[X,Y+3,Z+3],[X,Y+4,Z+3],[X,Y+4,Z+2],[X,Y+4,Z+1],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	let FrameDestroyWest = [[X,Y,Z-1],[X,Y,Z-2],[X,Y,Z-3],[X,Y+1,Z-3],[X,Y+2,Z-3],[X,Y+3,Z-3],[X,Y+4,Z-3],[X,Y+4,Z-2],[X,Y+4,Z-1],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	let FrameDestroySouth = [[X-1,Y,Z], [X-2,Y,Z],[X-3,Y,Z],[X-3,Y+1,Z],[X-3,Y+2,Z],[X-3,Y+3,Z],[X-3,Y+4,Z],[X-2,Y+4,Z],[X-1,Y+4,Z],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	let FrameDestroyNorth = [[X+1,Y,Z], [X+2,Y,Z],[X+3,Y,Z],[X+3,Y+1,Z],[X+3,Y+2,Z],[X+3,Y+3,Z],[X+3,Y+4,Z],[X+2,Y+4,Z],[X+1,Y+4,Z],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	if (validBlocks.includes(blockID)) {
		this.runCommand(`/playsound beacon.deactivate ${playerName}`);
		this.runCommand(`/tickingarea remove tick_area_lime_${X}_${Y}_${Z}`)
		if (direction == "east") {
			//kill the portal
			this.runCommand(`/tp @e[x=${X+0.5},y=${Y+1},z=${Z+2},dx=0,dy=0,dz=0] ${X} ${Y-1000} ${Z}`);

			//Change scoreboard
			if (portalBScore == 1 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_B___ portals_data 0`);
			}
			else if (portalBScore == 0 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_A___ portals_data 0`);
			};
			//Revert frame back to frame blocks
			for (i=0;i < 14;i++) {
				this.createBlock(FrameDestroyEast[i],"portal_frame")
			}
		}
		else if (direction == "west") {
			//kill the portal
			this.runCommand(`/tp @e[x=${X+0.5},y=${Y+1},z=${Z-1},dx=0,dy=0,dz=0] ${X} ${Y-1000} ${Z}`);

			//Change scoreboard
			if (portalBScore == 1 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_B___ portals_data 0`);
			}
			else if (portalBScore == 0 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_A___ portals_data 0`);
			};
			//Revert frame back to frame blocks
			for (i=0;i < 14;i++) {
				this.createBlock(FrameDestroyWest[i],"portal_frame")
			}
		}
		else if (direction == "south") {
			//kill the portal
			this.runCommand(`/tp @e[x=${X-1},y=${Y+1},z=${Z+0.5},dx=0,dy=0,dz=0] ${X} ${Y-1000} ${Z}`);

			//Change scoreboard
			if (portalBScore == 1 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_B___ portals_data 0`);
			}
			else if (portalBScore == 0 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_A___ portals_data 0`);
			};
			//Revert frame back to frame blocks
			for (i=0;i < 14;i++) {
				this.createBlock(FrameDestroySouth[i],"portal_frame")
			}
		}
		else if (direction == "north") {
			//kill the portal
			this.runCommand(`/tp @e[x=${X+2},y=${Y+1},z=${Z+0.5},dx=0,dy=0,dz=0] ${X} ${Y-1000} ${Z}`);

			//Change scoreboard
			if (portalBScore == 1 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_B___ portals_data 0`);
			}
			else if (portalBScore == 0 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_A___ portals_data 0`);
			};
			//Revert frame back to frame blocks
			for (i=0;i < 14;i++) {
				this.createBlock(FrameDestroyNorth[i],"portal_frame")
			}
		}
	}
};

system.onInteract = function(eventData) {
	let X = eventData.data.block_position.x;
	let Y = eventData.data.block_position.y;
	let Z = eventData.data.block_position.z;
	let blockID = this.getBlockId(X,Y,Z)
	let handItem = this.getHeldItem(0);
	let command = "portal_controller_";
	let direction = blockID.slice(31,37);
	let FrameDestroyEast = [[X,Y,Z+1],[X,Y,Z+2],[X,Y,Z+3],[X,Y+1,Z+3],[X,Y+2,Z+3],[X,Y+3,Z+3],[X,Y+4,Z+3],[X,Y+4,Z+2],[X,Y+4,Z+1],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	let FrameDestroyWest = [[X,Y,Z-1],[X,Y,Z-2],[X,Y,Z-3],[X,Y+1,Z-3],[X,Y+2,Z-3],[X,Y+3,Z-3],[X,Y+4,Z-3],[X,Y+4,Z-2],[X,Y+4,Z-1],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	let FrameDestroySouth = [[X-1,Y,Z], [X-2,Y,Z],[X-3,Y,Z],[X-3,Y+1,Z],[X-3,Y+2,Z],[X-3,Y+3,Z],[X-3,Y+4,Z],[X-2,Y+4,Z],[X-1,Y+4,Z],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	let FrameDestroyNorth = [[X+1,Y,Z], [X+2,Y,Z],[X+3,Y,Z],[X+3,Y+1,Z],[X+3,Y+2,Z],[X+3,Y+3,Z],[X+3,Y+4,Z],[X+2,Y+4,Z],[X+1,Y+4,Z],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
 if (handItem == "portals:portal_destroyer" && validBlocks.includes(blockID)) {
		this.runCommand(`/setblock ${X} ${Y} ${Z} ${command + direction.trim()}`);
		this.runCommand(`/playsound beacon.deactivate ${playerName}`);
		this.runCommand(`/tickingarea remove tick_area_lime_${X}_${Y}_${Z}`)
		if (direction == "east") {
			//kill the portal
			this.runCommand(`/tp @e[x=${X+0.5},y=${Y+1},z=${Z+2},dx=0,dy=0,dz=0] ${X} ${Y-1000} ${Z}`);

			//Change scoreboard
			if (portalBScore == 1 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_B___ portals_data 0`);
			}
			else if (portalBScore == 0 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_A___ portals_data 0`);
			};
			//Revert frame back to frame blocks
			for (i=0;i < 14;i++) {
				this.createBlock(FrameDestroyEast[i],"portal_frame")
			};	
		}
		else if (direction == "west") {
			//kill the portal
			this.runCommand(`/tp @e[x=${X+0.5},y=${Y+1},z=${Z-1},dx=0,dy=0,dz=0] ${X} ${Y-1000} ${Z}`);

			//Change scoreboard
			if (portalBScore == 1 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_B___ portals_data 0`);
			}
			else if (portalBScore == 0 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_A___ portals_data 0`);
			};
			//Revert frame back to frame blocks
			for (i=0;i < 14;i++) {
				this.createBlock(FrameDestroyWest[i],"portal_frame")
			}
			
		}
		else if (direction == "south") {
			//kill the portal
			this.runCommand(`/tp @e[x=${X-1},y=${Y+1},z=${Z+0.5},dx=0,dy=0,dz=0] ${X} ${Y-1000} ${Z}`);

			//Change scoreboard
			if (portalBScore == 1 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_B___ portals_data 0`);
			}
			else if (portalBScore == 0 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_A___ portals_data 0`);
			};
			//Revert frame back to frame blocks
			for (i=0;i < 14;i++) {
				this.createBlock(FrameDestroySouth[i],"portal_frame")
			}
			
		}
		else if (direction == "north") {
			//kill the portal
			this.runCommand(`/tp @e[x=${X+2},y=${Y+1},z=${Z+0.5},dx=0,dy=0,dz=0] ${X} ${Y-1000} ${Z}`);

			//Change scoreboard
			if (portalBScore == 1 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_B___ portals_data 0`);
			}
			else if (portalBScore == 0 && portalAScore == 1) {
				this.runCommand(`/scoreboard players set lime_A___ portals_data 0`);
			};
			//Revert frame back to frame blocks
			for (i=0;i < 14;i++) {
				this.createBlock(FrameDestroyNorth[i],"portal_frame")
			}
			
		}
 }

};

//Scoreboard checks
system.scoreboardCheckA = function(result) {
	if (result.data.statusCode === 0) {
		portalAScore = 0;
	}
	else {
		portalAScore = 1;
	}
};
system.scoreboardCheckB = function(result) {
	if (result.data.statusCode === 0) {
		portalBScore = 0;
	}
	else {
		portalBScore = 1;
	}
};

system.update = function () {
	this.executeCommand(`/scoreboard players test lime_A___ portals_data 0 0`,(result) => system.scoreboardCheckA(result));
	this.executeCommand(`/scoreboard players test lime_B___ portals_data 0 0`,(result) => system.scoreboardCheckB(result));
};
system.runCommand = function(command) {
	eventData = this.createEventData("minecraft:execute_command")
	eventData.data.command = command
	this.broadcastEvent("minecraft:execute_command",eventData)
};
system.getBlockId = function(x,y,z) {
    let blockData = this.getBlock(playerTickingArea,x,y,z);
    let placedBlock = blockData.__identifier__;
    return placedBlock;
};
system.getBlockArrayId = function(array) {
    let blockData = this.getBlock(playerTickingArea,array[0],array[1],array[2]);
    let placedBlock = blockData.__identifier__;
    return placedBlock;
};
system.getHeldItem = function(hand) {
	let handContainer = this.getComponent(clientPlayer,"minecraft:hand_container");
	let handItem = handContainer.data[hand].__identifier__;
	return handItem;
};
system.chatMessage = function(message) {
	this.runCommand(`/say ${message}`)
};
system.createBlock = function(array,block) {
	this.runCommand(`/setblock ${array[0]} ${array[1]} ${array[2]} ${block}`);
}