let system = server.registerSystem(0,0);
let clientPlayer;
let PlayerName;
let playerX;
let playerY;
let playerZ;
let inEastlime;
let inNorthlime;
let inPortal = false;;
let start;
let justTeleported;
let needsReset;
let portalAScore;
let portalBScore;
system.initialize = function() {
    this.listenForEvent("portals:player_joined",(eventData) => system.onJoin(eventData));
};

system.onJoin = function(eventData) {
	clientPlayer = eventData.data.player;
	let getName = this.getComponent(clientPlayer,"minecraft:nameable");
	PlayerName = getName.data.name;
};

//Scoreboard checks
system.scoreboardCheckA = function(result) {
	if (result.data.statusCode === 0) {
		portalAScore = 0;
	}
	else {
		portalAScore = 1;
	}
};
system.scoreboardCheckB = function(result) {
	if (result.data.statusCode === 0) {
		portalBScore = 0;
	}
	else {
		portalBScore = 1;
	}
};

system.update = function () {
	this.executeCommand(`/scoreboard players test lime_A___ portals_data 0 0`,(result) => system.scoreboardCheckA(result));
	this.executeCommand(`/scoreboard players test lime_B___ portals_data 0 0`,(result) => system.scoreboardCheckB(result));
    //Update player coordinates;
    let playerPosition = this.getComponent(clientPlayer,"minecraft:position");
    playerX = Math.floor(playerPosition.data.x);
    playerY = Math.floor(playerPosition.data.y);
    playerZ = Math.floor(playerPosition.data.z);
    let teleportBar = [];
    teleportBar[0] = `§l§f==========`;
    teleportBar[1] = `§l§f=========§7=`;
    teleportBar[2] = `§l§f========§7==`;
    teleportBar[3] = `§l§f=======§7===`;
    teleportBar[4] = `§l§f======§7====`;
    teleportBar[5] = `§l§f=====§7=====`;
    teleportBar[6] = `§l§f====§7======`;
    teleportBar[7] = `§l§f===§7=======`;
    teleportBar[8] = `§l§f==§7========`;
    teleportBar[9] = `§l§f=§7=========`;
    teleportBar[10] = `§l§7==========`;
    let numbers = [0,5,10,15,20,25,30,35,40,45,50];
    //Test for portal entity at players location
    this.executeCommand(`/testfor @e[type=portals:lime_portal_east_west,x=${playerX},y=${playerY+2},z=${playerZ},dx=0,dy=-4,dz=1]`,(result) => system.testforEast(result));
    this.executeCommand(`/testfor @e[type=portals:lime_portal_north_south,x=${playerX},y=${playerY+2},z=${playerZ},dx=1,dy=-4,dz=0]`,(result) => system.testforNorth(result));
    //Add tag to portal you're in
    if (inEastlime || inNorthlime) {
        this.runCommand(`/tag @e[x=${playerX},y=${playerY+2},z=${playerZ},dx=0,dy=-4,dz=1] add in_portal_lime`);
        this.runCommand(`/tag @e[x=${playerX},y=${playerY+2},z=${playerZ},dx=1,dy=-4,dz=0] add in_portal_lime`);
        inPortal = true;

    }
    else if (!inEastlime && !inNorthlime) {
        this.runCommand(`/tag @e remove in_portal_lime`);
        inPortal = false;
        start = -1;
        if (needsReset) {
            this.runCommand(`/title ${PlayerName} times 0 0 0`);
            this.runCommand(`/title ${PlayerName} actionbar`);
            this.runCommand(`/title ${PlayerName} reset`);
            needsReset = false;
        }
    };
    //Teleport if standing in a portal;
    if (inPortal) {
        start++;
        if (numbers.includes(start) && portalBScore == 1 && portalAScore == 1) {
            let index = numbers.indexOf(start);
            this.runCommand(`/title ${PlayerName} times 0 0 0`);
            this.runCommand(`/title ${PlayerName} actionbar ${teleportBar[index]}`)
            needsReset = true;
        }
        if (start == 50) {
            this.executeCommand(`/tp ${PlayerName} @e[type=portals:lime_portal_east_west,tag=!in_portal_lime]`,(result) => system.teleportEastWest(result));
            this.executeCommand(`/tp ${PlayerName} @e[type=portals:lime_portal_north_south,tag=!in_portal_lime]`,(result) => system.teleportNorthSouth(result));
            playerX = playerPosition.data.x;
            playerY = playerPosition.data.y;
            playerZ = playerPosition.data.z;
            if (portalAScore == 1 && portalBScore == 1) {
                this.runCommand(`/playsound mob.shulker.teleport ${PlayerName}`);
                this.runCommand(`/title ${PlayerName} actionbar `);
                this.runCommand(`/title ${playerName} reset`)
                start = 0;
                justTeleported = true;
            }
            else {
                this.runCommand(`/title ${PlayerName} actionbar You can stand here all day, nothing's gonna happen. You need 2 §aLime §rportals.`)
            }

        }
    }
};

system.testforEast = function(result) {
    if (result.data.statusCode == 0) {
        inEastlime = true;
    }
    else {
        inEastlime = false;
    }
};
system.testforNorth = function(result) {
    if (result.data.statusCode == 0 ) {
        inNorthlime = true;
    }
    else {
        inNorthlime = false;
    }
};
system.teleportEastWest = function(result) {
    if (result.data.statusCode == 0) {
        this.runCommand(`/execute ${PlayerName} ~ ~ ~ /tp @s ~ ~ ~ 90 ~`);
    }
};
system.teleportNorthSouth = function(result) {
    if (result.data.statusCode == 0) {
        this.runCommand(`/execute ${PlayerName} ~ ~ ~ /tp @s ~ ~ ~ 180 ~`)
    }
};

system.runCommand = function(command) {
	eventData = this.createEventData("minecraft:execute_command")
	eventData.data.command = command
	this.broadcastEvent("minecraft:execute_command",eventData)
};