let system = server.registerSystem(0,0);
let clientPlayer;
let playerTickingArea;
let PlayerName
let validBlocks = ["portals:portal_controller_north", "portals:portal_controller_south", "portals:portal_controller_east", "portals:portal_controller_west"];
let magentaPortalAScore;
let magentaPortalBScore;

system.initialize = function() {
	this.listenForEvent("portals:player_joined",(eventData) => system.onJoin(eventData));
	this.listenForEvent("minecraft:block_interacted_with",(eventData) => system.onInteract(eventData));
};
system.onJoin = function(eventData) {
	clientPlayer = eventData.data.player;
    let tickWorld = this.getComponent(clientPlayer,"minecraft:tick_world");
	playerTickingArea = tickWorld.data.ticking_area;
	let getName = this.getComponent(clientPlayer,"minecraft:nameable");
	PlayerName = getName.data.name;
};

system.onInteract = function(eventData) {
	let X = eventData.data.block_position.x;
	let Y = eventData.data.block_position.y;
	let Z = eventData.data.block_position.z;
	let blockID = this.getBlockId(X,Y,Z)
	let handItem = this.getHeldItem(0);
	let command = "portal_controller_magenta_";
	let direction = blockID.slice(26,31);
	let block;

	//Portal frame validation arrays
	let FrameTestEast = [[X,Y,Z+1],[X,Y,Z+2],[X,Y,Z+3],[X,Y+1,Z+3],[X,Y+2,Z+3],[X,Y+3,Z+3],[X,Y+4,Z+3],[X,Y+4,Z+2],[X,Y+4,Z+1],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	let FrameTestWest = [[X,Y,Z-1],[X,Y,Z-2],[X,Y,Z-3],[X,Y+1,Z-3],[X,Y+2,Z-3],[X,Y+3,Z-3],[X,Y+4,Z-3],[X,Y+4,Z-2],[X,Y+4,Z-1],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	let FrameTestSouth = [[X-1,Y,Z], [X-2,Y,Z],[X-3,Y,Z],[X-3,Y+1,Z],[X-3,Y+2,Z],[X-3,Y+3,Z],[X-3,Y+4,Z],[X-2,Y+4,Z],[X-1,Y+4,Z],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	let FrameTestNorth = [[X+1,Y,Z], [X+2,Y,Z],[X+3,Y,Z],[X+3,Y+1,Z],[X+3,Y+2,Z],[X+3,Y+3,Z],[X+3,Y+4,Z],[X+2,Y+4,Z],[X+1,Y+4,Z],[X,Y+4,Z],[X,Y+3,Z],[X,Y+2,Z],[X,Y+1,Z]];
	if (validBlocks.includes(blockID) && handItem == "portals:magenta_portal_core") {
		if (magentaPortalBScore != 1) {
			this.runCommand(`/setblock ${eventData.data.block_position.x} ${eventData.data.block_position.y} ${eventData.data.block_position.z} ${command + direction.trim()}`);
		}
	
	
		//Frame validation
	for (i=0;i < 14;i++) {

		if (direction == "north") {
			block = this.getBlockArrayId(FrameTestNorth[i]);
		}
		else if (direction == "south") {
			block = this.getBlockArrayId(FrameTestSouth[i]);
		}
		else if (direction == "east") {
			block = this.getBlockArrayId(FrameTestEast[i]);
		}
		else if (direction == "west") {
			block = this.getBlockArrayId(FrameTestWest[i]);
		}

		if (block == "portals:portal_frame") {
			if (i == 12) {
				if (magentaPortalBScore != 1) {

				this.runCommand(`/clear ${PlayerName} portals:magenta_portal_core 0 1`);

				if (direction == "east") {
					this.runCommand(`/fill ${X} ${Y+1} ${Z+1} ${X} ${Y+3} ${Z+2} air 0 destroy`);
					//If poral frame is valid, creates a connected frame
					this.createBlock(FrameTestEast[0],"frame_pillar_side_c");
					this.createBlock(FrameTestEast[1],"frame_pillar_side_c");
					this.createBlock(FrameTestEast[2],"frame_corner_g");
					this.createBlock(FrameTestEast[3],"frame_pillar_up_c");
					this.createBlock(FrameTestEast[4],"frame_pillar_up_c");
					this.createBlock(FrameTestEast[5],"frame_pillar_up_c");
					this.createBlock(FrameTestEast[6],"frame_corner_e");
					this.createBlock(FrameTestEast[7],"frame_pillar_side_d");
					this.createBlock(FrameTestEast[8],"frame_pillar_side_d");
					this.createBlock(FrameTestEast[9],"frame_corner_d");
					this.createBlock(FrameTestEast[10],"frame_pillar_up_d");
					this.createBlock(FrameTestEast[11],"frame_pillar_up_d");
					this.createBlock(FrameTestEast[12],"frame_pillar_up_d");
					//Function
					system.createPortal = function(id) {
						//Create portal entity
						let portal = this.createEntity("entity",id);
						let portalPosition = this.getComponent(portal,"minecraft:position");
						portalPosition.data.x = X+0.5;
						portalPosition.data.y = Y+1;
						portalPosition.data.z = Z+2;
						this.applyComponentChanges(portal,portalPosition);
						this.runCommand(`/playsound beacon.activate ${PlayerName}`);
					};
					//Portal Creation
					if (magentaPortalAScore == 0 && magentaPortalBScore == 0){
						this.runCommand(`/scoreboard players set magenta_A___ portals_data 1`);
						this.createPortal("portals:magenta_portal_east_west");
						this.runCommand(`/tickingarea add circle ${X} ${Y} ${Z} 1 tick_area_magenta_${X}_${Y}_${Z}`);
					}
					else if (magentaPortalAScore == 1 && magentaPortalBScore == 0) {
						this.runCommand(`/scoreboard players set magenta_B___ portals_data 1`)
						this.createPortal("portals:magenta_portal_east_west");
						this.runCommand(`/tickingarea add circle ${X} ${Y} ${Z} 1 tick_area_magenta_${X}_${Y}_${Z}`);
					}
				}
				else if (direction == "west") {
					this.runCommand(`/fill ${X} ${Y+1} ${Z-1} ${X} ${Y+3} ${Z-2} air 0 destroy`);
					this.createBlock(FrameTestWest[0],"frame_pillar_side_c");
					this.createBlock(FrameTestWest[1],"frame_pillar_side_c");
					this.createBlock(FrameTestWest[2],"frame_corner_f");
					this.createBlock(FrameTestWest[3],"frame_pillar_up_d");
					this.createBlock(FrameTestWest[4],"frame_pillar_up_d");
					this.createBlock(FrameTestWest[5],"frame_pillar_up_d");
					this.createBlock(FrameTestWest[6],"frame_corner_d");
					this.createBlock(FrameTestWest[7],"frame_pillar_side_d");
					this.createBlock(FrameTestWest[8],"frame_pillar_side_d");
					this.createBlock(FrameTestWest[9],"frame_corner_e");
					this.createBlock(FrameTestWest[10],"frame_pillar_up_c");
					this.createBlock(FrameTestWest[11],"frame_pillar_up_c");
					this.createBlock(FrameTestWest[12],"frame_pillar_up_c");
					//function
					system.createPortal = function(id) {
						let portal = this.createEntity("entity",id);
						let portalPosition = this.getComponent(portal,"minecraft:position");
						portalPosition.data.x = X+0.5;
						portalPosition.data.y = Y+1;
						portalPosition.data.z = Z-1;
						this.applyComponentChanges(portal,portalPosition);
						this.runCommand(`/playsound beacon.activate ${PlayerName}`);
					};
					//Portal Creation
					if (magentaPortalAScore == 0 && magentaPortalBScore == 0){
						this.runCommand(`/scoreboard players set magenta_A___ portals_data 1`);
						this.createPortal("portals:magenta_portal_east_west");
						this.runCommand(`/tickingarea add circle ${X} ${Y} ${Z} 1 tick_area_magenta_${X}_${Y}_${Z}`);
					}
					else if (magentaPortalAScore == 1 && magentaPortalBScore == 0) {
						this.runCommand(`/scoreboard players set magenta_B___ portals_data 1`)
						this.createPortal("portals:magenta_portal_east_west");
						this.runCommand(`/tickingarea add circle ${X} ${Y} ${Z} 1 tick_area_magenta_${X}_${Y}_${Z}`);
					}
				}
				else if (direction == "south") {
					this.runCommand(`/fill ${X-1} ${Y+1} ${Z} ${X-2} ${Y+3} ${Z} air 0 destroy`);
					this.createBlock(FrameTestSouth[0],"frame_pillar_side_b");
					this.createBlock(FrameTestSouth[1],"frame_pillar_side_b");
					this.createBlock(FrameTestSouth[2],"frame_corner_h");
					this.createBlock(FrameTestSouth[3],"frame_pillar_up_a");
					this.createBlock(FrameTestSouth[4],"frame_pillar_up_a");
					this.createBlock(FrameTestSouth[5],"frame_pillar_up_a");
					this.createBlock(FrameTestSouth[6],"frame_corner_b");
					this.createBlock(FrameTestSouth[7],"frame_pillar_side_a");
					this.createBlock(FrameTestSouth[8],"frame_pillar_side_a");
					this.createBlock(FrameTestSouth[9],"frame_corner_a");
					this.createBlock(FrameTestSouth[10],"frame_pillar_up_b");
					this.createBlock(FrameTestSouth[11],"frame_pillar_up_b");
					this.createBlock(FrameTestSouth[12],"frame_pillar_up_b");
					//function
					system.createPortal = function(id) {
						let portal = this.createEntity("entity",id);
						let portalPosition = this.getComponent(portal,"minecraft:position");
						portalPosition.data.x = X-1;
						portalPosition.data.y = Y+1;
						portalPosition.data.z = Z+0.5;
						this.applyComponentChanges(portal,portalPosition);
						this.runCommand(`/playsound beacon.activate ${PlayerName}`)
					};
					//Portal Creation
					if (magentaPortalAScore == 0 && magentaPortalBScore == 0){
						this.runCommand(`/scoreboard players set magenta_A___ portals_data 1`);
						this.createPortal("portals:magenta_portal_north_south");
						this.runCommand(`/tickingarea add circle ${X} ${Y} ${Z} 1 tick_area_magenta_${X}_${Y}_${Z}`);
					}
					else if (magentaPortalAScore == 1 && magentaPortalBScore == 0) {
						this.runCommand(`/scoreboard players set magenta_B___ portals_data 1`)
						this.createPortal("portals:magenta_portal_north_south");
						this.runCommand(`/tickingarea add circle ${X} ${Y} ${Z} 1 tick_area_magenta_${X}_${Y}_${Z}`);
					}
				}
				else if (direction == "north") {
					this.runCommand(`/fill ${X+1} ${Y+1} ${Z} ${X+2} ${Y+3} ${Z} air 0 destroy`);
					this.createBlock(FrameTestNorth[0],"frame_pillar_side_b");
					this.createBlock(FrameTestNorth[1],"frame_pillar_side_b");
					this.createBlock(FrameTestNorth[2],"frame_corner_c");
					this.createBlock(FrameTestNorth[3],"frame_pillar_up_b");
					this.createBlock(FrameTestNorth[4],"frame_pillar_up_b");
					this.createBlock(FrameTestNorth[5],"frame_pillar_up_b");
					this.createBlock(FrameTestNorth[6],"frame_corner_a");
					this.createBlock(FrameTestNorth[7],"frame_pillar_side_a");
					this.createBlock(FrameTestNorth[8],"frame_pillar_side_a");
					this.createBlock(FrameTestNorth[9],"frame_corner_b");
					this.createBlock(FrameTestNorth[10],"frame_pillar_up_a");
					this.createBlock(FrameTestNorth[11],"frame_pillar_up_a");
					this.createBlock(FrameTestNorth[12],"frame_pillar_up_a");
					//function
					system.createPortal = function(id) {
						let portal = this.createEntity("entity",id);
						let portalPosition = this.getComponent(portal,"minecraft:position");
						portalPosition.data.x = X+2;
						portalPosition.data.y = Y+1;
						portalPosition.data.z = Z+0.5;
						this.applyComponentChanges(portal,portalPosition);
						this.runCommand(`/playsound beacon.activate ${PlayerName}`)
					};
					//Portal Creation
					if (magentaPortalAScore == 0 && magentaPortalBScore == 0){
						this.runCommand(`/scoreboard players set magenta_A___ portals_data 1`);
						this.createPortal("portals:magenta_portal_north_south");
						this.runCommand(`/tickingarea add circle ${X} ${Y} ${Z} 1 tick_area_magenta_${X}_${Y}_${Z}`);
					}
					else if (magentaPortalAScore == 1 && magentaPortalBScore == 0) {
						this.runCommand(`/scoreboard players set magenta_B___ portals_data 1`)
						this.createPortal("portals:magenta_portal_north_south");
						this.runCommand(`/tickingarea add circle ${X} ${Y} ${Z} 1 tick_area_magenta_${X}_${Y}_${Z}`);
					}
				}
			}
			else {
				this.runCommand(`/title ${PlayerName} actionbar Only 2 §dMagenta §rportals can be linked!`)
			}
		  }
		}
		else {
			this.runCommand(`/title ${PlayerName} actionbar Invalid Portal Frame!`)
			this.runCommand(`/setblock ${eventData.data.block_position.x} ${eventData.data.block_position.y} ${eventData.data.block_position.z} ${"portal_controller_" + direction.trim()}`);
			break;
		};
		

		}
	}
}

//Scoreboard checks
system.scoreboardCheckA = function(result) {
	if (result.data.statusCode === 0) {
		magentaPortalAScore = 0;
	}
	else {
		magentaPortalAScore = 1;
	}
};
system.scoreboardCheckB = function(result) {
	if (result.data.statusCode === 0) {
		magentaPortalBScore = 0;
	}
	else {
		magentaPortalBScore = 1;
	}
};


system.update = function () {
	this.executeCommand(`/scoreboard players test magenta_A___ portals_data 0 0`,(result) => system.scoreboardCheckA(result));
	this.executeCommand(`/scoreboard players test magenta_B___ portals_data 0 0`,(result) => system.scoreboardCheckB(result));
};
system.runCommand = function(command) {
	eventData = this.createEventData("minecraft:execute_command")
	eventData.data.command = command
	this.broadcastEvent("minecraft:execute_command",eventData)
};
system.getBlockId = function(x,y,z) {
    let blockData = this.getBlock(playerTickingArea,x,y,z);
    let placedBlock = blockData.__identifier__;
    return placedBlock;
};
system.getBlockArrayId = function(array) {
    let blockData = this.getBlock(playerTickingArea,array[0],array[1],array[2]);
    let placedBlock = blockData.__identifier__;
    return placedBlock;
};
system.getHeldItem = function(hand) {
	let handContainer = this.getComponent(clientPlayer,"minecraft:hand_container");
	let handItem = handContainer.data[hand].__identifier__;
	return handItem;
};
system.chatMessage = function(message) {
	this.runCommand(`/say ${message}`)
};
system.createBlock = function(array,block) {
	this.runCommand(`/setblock ${array[0]} ${array[1]} ${array[2]} ${block}`);
}